{% extends 'layouts/main.html' %}
{% import 'bootstrap/wtf.html' as wtf %}

{% block title %}Migrační aplikace CKAN → LKOD{% endblock %}

{% block content %}

<div class="container">

    {% with messages = get_flashed_messages(with_categories=True) %}
    {% if messages %}
    {% for category, message in messages %}
    <div class="alert alert-{{category}}" role="alert">{{ message }}</div>
    {% endfor %}
    {% endif %}
    {% endwith %}
    {% if not migration_form %}
    <div class="row">
        <div class="col-sm-12 col-md-6 col-lg-6 col-center">
            <div class="well">

                <form method=post>
                    {{ form.csrf_token }}
                    <div class="panel" id="panel-ckan">
                        <div class="panel-heading">
                            <h3 class="panel-title">Konfigurace CKAN</h3>
                        </div>
                        <div class="panel-body">
                            <div class="form-group ">

                                {{ form.ckan_server_url.label(class='control-label', text='URL serveru *') }}
                                {{ form.ckan_server_url(class='form-control') }}

                                {% for error in form.ckan_server_url.errors %}
                                <li>{{ error }}</li>
                                {% endfor %}
                            </div>

                            <div class="form-group ">

                                {{ form.ckan_api_key.label(class='control-label', text='API klíč') }}
                                {{ form.ckan_api_key(class='form-control') }}
                                {% for error in form.ckan_api_key.errors %}
                                <li>{{ error }}</li>
                                {% endfor %}
                            </div>

                            <div class="form-group ">

                                {{ form.ckan_organization_name.label(class='control-label', text='ID Organizace') }}
                                <a class="" role="button" data-toggle="collapse" href="#ckan-organization-name-info"
                                    aria-expanded="false" aria-controls="collapseExample"><span
                                        class="glyphicon glyphicon-search"></span>
                                </a>
                                <div class="collapse" id="ckan-organization-name-info">
                                    <div class="well">
                                        <p class="form-text text-muted">ID Organizace slouží pro filtraci datových
                                            sad konkrétní organizace.<br />
                                            Název organizace je unikátním identifikátorem, který naleznete v aplikaci
                                            CKAN jako její název.<br />
                                            Pro rychlé nalezení stačí zkopírovat název organizace z URL adresy při
                                            vyfiltrování datasetů konkrétní organizace.<br />
                                            Pro URL: https://opendata.praha.eu/organization/pvs-a-pvk je ID organizace
                                            rovno: <strong>pvs-a-pvk</strong><br /><br />
                                            Pokud není určeno, provede se migrace celého CKAN serveru pod jednu
                                            organizaci.
                                        </p>
                                    </div>
                                </div>
                                {{ form.ckan_organization_name(class='form-control') }}
                                {% for error in form.ckan_organization_name.errors %}
                                <li>{{ error }}</li>
                                {% endfor %}
                            </div>
                        </div>
                    </div>

                    <div class="panel" id="panel-lkod">
                        <div class="panel-heading">
                            <h3 class="panel-title">Konfigurace LKOD</h3>
                        </div>
                        <div class="panel-body">
                            <div class="form-group ">
                                {{ form.lkod_server_url.label(class='control-label', text='URL serveru *') }}
                                <a class="" role="button" data-toggle="collapse" href="#lkod-server-url-info"
                                    aria-expanded="false" aria-controls="collapseExample"><span
                                        class="glyphicon glyphicon-search"></span>
                                </a>
                                <div class="collapse" id="lkod-server-url-info">
                                    <div class="well">
                                        <p class="form-text text-muted">
                                            URL serveru LKOD musí směřovat na základní API endpoint LKOD.<br/>
                                            Výstup API by měl odpovídat výstupu na adrese: https://api-lkod.rabin.golemio.cz/
                                            <br />
                                            URL je možné zadat s koncovým lomítkem i bez. Aplikace sama upraví URL na správnou hodnotu.
                                        </p>
                                    </div>
                                </div>
                                {{ form.lkod_server_url(class='form-control') }}
                                {% for error in form.lkod_server_url.errors %}
                                <li>{{ error }}</li>
                                {% endfor %}
                            </div>

                            <div class="form-group ">
                                {{ form.username.label(class='control-label', text='Uživatelské jméno *') }}
                                {{ form.username(class='form-control') }}
                                {% for error in form.username.errors %}
                                <li>{{ error }}</li>
                                {% endfor %}
                            </div>
                            <div class="form-group ">
                                {{ form.password.label(class='control-label', text='Heslo *') }}
                                {{ form.password(class='form-control') }}
                                {% for error in form.password.errors %}
                                <li>{{ error }}</li>
                                {% endfor %}
                            </div>


                            <div class="form-group ">
                                {{ form.company_vatin.label(class='control-label', text='IČO instituce *') }}
                                <a class="" role="button" data-toggle="collapse" href="#lkod-company-vatin-info"
                                    aria-expanded="false" aria-controls="collapseExample"><span
                                        class="glyphicon glyphicon-search"></span>
                                </a>
                                <div class="collapse" id="lkod-company-vatin-info">
                                    <div class="well">
                                        <p class="form-text text-muted">
                                            IČO instituce by mělo odpovídat IČO jedné z organizací v aplikaci LKOD.
                                            <br />
                                            Instituce v této aplikaci musí být zaregistrována. Pokud byla organizace
                                            sjednocena s jinou,
                                            prosím vyplňte ID organizace pro LKOD v dalším poli.
                                            <br />
                                            <br />
                                            ID instituce Vám sdělí správce aplikace.
                                            <br />
                                            <br />
                                            Pokud vyplníte <strong>ID instituce</strong>, automaticky bude brato pro
                                            účely
                                            migrace toto ID a ID instituce <strong>nebude</strong> dohledáváno podle
                                            IČO.
                                        </p>
                                    </div>
                                </div>
                                {{ form.company_vatin(class='form-control') }}
                                {% for error in form.company_vatin.errors %}
                                <li>{{ error }}</li>
                                {% endfor %}
                            </div>
                            <div class="form-group ">

                                <a class="" role="button" data-toggle="collapse" href="#lkod-company-id-info"
                                    aria-expanded="false" aria-controls="collapseExample">Manuální Nastavení ID
                                    instituce <span class="glyphicon glyphicon-pencil"></span>
                                </a>
                                <div class="collapse" id="lkod-company-id-info">
                                    {{ form.lkod_company_id.label(class='control-label', text='ID instituce v LKOD') }}
                                    {{ form.lkod_company_id(class='form-control') }}
                                    {% for error in form.lkod_company_id.errors %}
                                    <li>{{ error }}</li>
                                    {% endfor %}
                                </div>
                            </div>

                        </div>
                    </div>

                    <div class="form-group ">
                        <div class="col-sm-12 col-md-6 col-lg-6 col-right">
                            {{ form.login_form_submit(class='btn btn-primary') }}
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
    {% endif %}

    {% if form.is_ready() %}
    <div class="row">
        <div class="col-sm-12 col-md-8 col-center">
            <div class="well">
                <h2>Stav migrace</h2>

                <h3>Stav: Datové sady staženy, připraveny k migraci</h3>


                <form method=post>
                    {{ migration_form.csrf_token }}
                    <div class="panel" id="panel-migration">
                        <div class="panel-heading">
                            <h3 class="panel-title">Konfigurace migrace</h3>
                        </div>
                        <div class="panel-body">
                            <div class="form-group">
                                {{ migration_form.variant.label(class='control-label', text='Které datové sady máme
                                zmigrovat?')
                                }}
                                {{ migration_form.variant(class='form-control') }}
                                {% for error in migration_form.variant.errors %}
                                <li>{{ error }}</li>
                                {% endfor %}
                            </div>
                            <div class="form-group">
                                {{ migration_form.prefill_frequency_check.label(class='control-label', text='Předvyplnit
                                frekvenci?') }}
                                {{ migration_form.prefill_frequency_check(class='') }}
                                {% for error in migration_form.prefill_frequency_check.errors %}
                                <li>{{ error }}</li>
                                {% endfor %}
                                <script>
                                    jQuery(document).ready(
                                        function ($) {
                                            $('#prefill_frequency_check').on("click", function () {
                                                console.log($(this));
                                                var $el = $('#prefill_frequency');
                                                if ($(this).is(":checked")) {
                                                    $el.parent().slideDown();
                                                }
                                                else {
                                                    $el.parent().slideUp();
                                                }


                                            })

                                        })



                                </script>
                            </div>
                            <div class="form-group" style="display:none">
                                {{ migration_form.prefill_frequency.label(class='control-label', text='Frekvence') }}
                                {{ migration_form.prefill_frequency(class='form-control') }}
                                {% for error in migration_form.prefill_frequency.errors %}
                                <li>{{ error }}</li>
                                {% endfor %}
                            </div>
                            <div class="form-group">
                                {{ migration_form.prefill_ruian_check.label(class='control-label', text='Předvyplnit
                                RÚIAN?') }}
                                {{ migration_form.prefill_ruian_check(class='') }}
                                {% for error in migration_form.prefill_ruian_check.errors %}
                                <li>{{ error }}</li>
                                {% endfor %}
                                <script>
                                    jQuery(document).ready(
                                        function ($) {
                                            $('#prefill_ruian_check').on("click", function () {
                                                console.log($(this));
                                                var $el = $('#prefill_ruian');
                                                if ($(this).is(":checked")) {
                                                    $el.parent().slideDown();
                                                }
                                                else {
                                                    $el.parent().slideUp();
                                                }


                                            })

                                        })



                                </script>
                            </div>
                            <div class="form-group" style="display:none">
                                {{ migration_form.prefill_ruian.label(class='control-label', text='RÚIAN') }}
                                {{ migration_form.prefill_ruian(class='form-control') }}
                                {% for error in migration_form.prefill_ruian.errors %}
                                <li>{{ error }}</li>
                                {% endfor %}
                            </div>
                            <div class="form-group">
                                {{ migration_form.prefill_license_check.label(class='control-label', text='Předvyplnit
                                licenci?') }}
                                {{ migration_form.prefill_license_check(class='') }}
                                {% for error in migration_form.prefill_license_check.errors %}
                                <li>{{ error }}</li>
                                {% endfor %}
                                <script>
                                    jQuery(document).ready(
                                        function ($) {
                                            $('#prefill_license_check').on("click", function () {
                                                console.log($(this));
                                                var $el = $('#prefill_license');
                                                if ($(this).is(":checked")) {
                                                    $el.parent().slideDown();
                                                }
                                                else {
                                                    $el.parent().slideUp();
                                                }


                                            })

                                        })



                                </script>
                            </div>
                            <div class="form-group" style="display:none">
                                {{ migration_form.prefill_license.label(class='control-label', text='Licence') }}
                                {{ migration_form.prefill_license(class='form-control') }}
                                {% for error in migration_form.prefill_license.errors %}
                                <li>{{ error }}</li>
                                {% endfor %}
                            </div>
                        </div>
                    </div>

                    <div class="form-group">

                        {% for status in dataset_status %}
                        <div class="panel panel-default">
                            <div class="panel-heading" role="tab" id="headingOne">
                                <h4 class="panel-title">
                                    <a role="button" data-toggle="collapse" href="#datasets-info-{{ status.value }}"
                                        aria-expanded="true" aria-controls="datasets-info-{{ status.value }}">
                                        Seznam datových sad ve stavu: {{ status.label() }} ({{
                                        form.datasets[status.value]|length }})
                                    </a>
                                </h4>
                            </div>
                            <div class="collapse" id="datasets-info-{{ status.value }}">
                                <div class="panel-collapse collapse in">
                                    <table class="table">
                                        <thead>
                                            <tr>
                                                <th>Identifikátor sady</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            {% for dataset in form.datasets[status.value] %}
                                            <tr>
                                                <th>
                                                    {{ dataset }}
                                                </th>
                                                {% if status == dataset_status.INVALID %}
                                                <td>
                                                    <button type="button" data-toggle="modal"
                                                        data-target="#{{dataset}}-modal">
                                                        Prohlédnout chyby
                                                    </button>
                                                    <div class="modal fade" id="{{dataset}}-modal" tabindex="-1"
                                                        role="dialog"
                                                        data-href="{{ url_for('site.validate', dataset=dataset) }}">
                                                        <div class="modal-dialog" role="document">
                                                            <div class="modal-content">
                                                                <div class="modal-header">
                                                                    <button type="button" class="close"
                                                                        data-dismiss="modal" aria-label="Close"><span
                                                                            aria-hidden="true">&times;</span>
                                                                    </button>
                                                                    <h4 class="modal-title" id="myModalLabel">Informace
                                                                        o
                                                                        problémech datové sady</h4>
                                                                </div>
                                                                <ul class="modal-body">
                                                                    ...
                                                                </ul>
                                                                <div class="modal-footer">
                                                                    <button type="button" class="btn btn-default"
                                                                        data-dismiss="modal">Close
                                                                    </button>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </td>
                                                <script>
                                                    jQuery(document).ready(
                                                        function ($) {
                                                            $('[data-target=\'#{{dataset}}-modal\']').on("click", function () {
                                                                var $modal = $("#{{dataset}}-modal")
                                                                $.get({
                                                                    url: $modal.data('href'), success: function (response) {
                                                                        var $modalBody = $modal.find(".modal-body");
                                                                        $modalBody.empty();
                                                                        $.each(response, function(index, item) {
                                                                            var listItem = $("<li>").text(item);
                                                                            $modalBody.append(listItem);
                                                                        });
                                                                    }
                                                                })

                                                            })

                                                        })



                                                </script>
                                                {% endif %}
                                            </tr>
                                            {% endfor %}
                                        </tbody>
                                    </table>

                                </div>
                            </div>
                        </div>
                        {% endfor %}

                        {{ migration_form.datasets(value=form.datasets) }}
                    </div>
                    <div class="form-group ">
                        <div class="col-sm-12 col-md-6 col-lg-6 col-right">
                            {{ migration_form.migration_form_submit(class='btn btn-primary btn-centered') }}
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
    {% endif %}
</div>
{% endblock %}